From 2824cfc6f1bd6e207e1be8ede4307063a3b6d6af Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 15 2017 11:12:40 +0000
Subject: [PATCH 801/1001] Test the config view


---

diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 2daa6e9..442a4e9 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -396,3 +396,46 @@ class HubsAPITest(hubs.tests.APPTest):
             url = '/source/notexistent'
             result = self.app.get(url)
             self.assertEqual(result.status_code, 404)
+
+    def test_hub_config_get(self):
+        expected = {
+            "hub": {
+                "summary": "Ralph",
+                "left_width": 8,
+                "avatar": (
+                    "https://seccdn.libravatar.org/avatar/9c9f7784935381befc30"
+                    "2fe3c814f9136e7a33953d0318761669b8643f4df55c?s=312&d=retro"
+                    ),
+                "chat_channel": None,
+                "chat_domain": None,
+            },
+            "general": {
+                "chat_networks": app.config["CHAT_NETWORKS"],
+            },
+        }
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            url = '/ralph/config'
+            result = self.app.get(url)
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertDictEqual(result_data["result"], expected)
+
+    def test_hub_config_post(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            url = '/ralph/config'
+            result = self.app.post(url, data={
+                "summary": "changed value",
+                "chat_domain": "",
+            })
+        self.assertEqual(result.status_code, 200)
+        result_data = json.loads(result.get_data(as_text=True))
+        self.assertEqual(result_data["status"], "OK")
+        self.assertEqual(
+            result_data["result"]["hub"]["summary"],
+            "changed value")
+        self.assertEqual(
+            result_data["result"]["hub"]["chat_domain"],
+            app.config["CHAT_NETWORKS"][0]["domain"])
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 253c132..2477056 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -157,6 +157,8 @@ def hub_config(name):
     if flask.request.method == 'POST':
         for key in hub.config.__json__():
             # Security: don't save every key in the POST.
+            if key not in flask.request.form:
+                continue
             setattr(hub.config, key, flask.request.form[key])
         if (not flask.request.form["chat_domain"]
             and len(app.config["CHAT_NETWORKS"]) > 0):

